#include <iostream>
//1
#include <chrono>
#include <ctime>
#include "funkcije_za_sortiranje.h"

using namespace std;

//2
using namespace std::chrono;

int genRnd(int min, int max)
{
	return rand() % (max - min + 1) + min;
}

int* prepare(int length) {
	int* arr = new int[length]; //dinamicka memorija, ako nemamo delete biti ce memory leak
	for (size_t i = 0; i < length; i++)
	{
		arr[i] = genRnd(1, 100);
	}
	return arr;
}

int* copy_array(int* orig, int length) 
{
	int* arr = new int[length];
	for (size_t i = 0; i < length; i++)
	{
		arr[i] = length;
	}
};

int main() {
	
	srand(time(nullptr));
	int length = 1000;
	int* arr = prepare(length);
	int* copy = copy_array(arr, length);

	//3
	auto begin = high_resolution_clock::now();
	
	//4 perform work
	quick_sort(arr, length);


	//5
	auto end = high_resolution_clock::now();

	// 6 
	cout << duration_cast <milliseconds> (end - begin).count() << " ns" << endl;

	//cpp zivi implementacija, a u headeru deklaracija
	// dinamicka i staticka memorija


	begin = high_resolution_clock::now();

	bubble_sort(copy, length); //bubble je n^2  jer je for u for i trebat ce duze vremena za izvrsit

	end = high_resolution_clock::now();

	cout << duration_cast <milliseconds> (end - begin).count() << " ns" << endl;


	delete[] arr;
	delete[] copy;

	return 0;
}